/* ************************************************************************** */
/*                                       _____           _                    */
/*  main.c                              |_   _|__  _   _| |__   ___ _   _     */
/*  | Project: cake.exe                   | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2017/01/16 18:05:41                               |___/     */
/*                                                                            */
/* ************************************************************************** */

#include <main.h>
#include <tales.h>
#include <keyboard.h>
#include <display.h>

/* reboot like an update.exe - that means re-running the bootcode */
static void (*reboot)(void) = (void*)0xa0000000;

/**
 *	main:
 *	User-friendly entry point of the program.
 */

int main(void)
{
	/* first display */
	dclear();
	dtext(1, 1, "CAKE.EXE");
	dupdate();

	/* wait for user to press on EXIT */
	while (1) {
		int key = getkey();
		if (key == KEY_EXIT)
			break;
	}

	/* we're done */
	(*reboot)();
}
